/*-------------------------------------------------------------------------
ADC test function (main.c)
Copyright: Maxim Integrated Products
Target: MAX7651
Date: Feb 26, 2004

Description: This program will convert 8 channels using the MAX7651
and send the results to Serial Port 0
--------------------------------------------------------------------------*/
#include <reg51.h>								//include MAX7651 register definitions
#include <stdio.h>								//Standard I/O, Print() function.

#define NUMBER_OF_CHANNELS 8					//Convert 8 channels

void convert_all_channels(int* buffer);			//Function declaration
int convert_channel(int adc_ch);  				//Function declaration

void main(void)									//Begin Main()
{
	int Adc_Results[NUMBER_OF_CHANNELS];		//Array to store conversion result
	int i;										//for loop counter

	convert_all_channels(Adc_Results);			//Convert all channels, Store results in Adc_Results

	#ifndef MONITOR51							//Setup Serial Port if not using Keil Monitor
	SCON  = 0x50;								//9600 Baud, 8N1, Xon, Xoff 
	TMOD |= 0x20;
	TH1   = 0xFA;
	TR1   = 1;
	TI    = 1;
	PCON |= 0x80;
	#endif

	for (i=0; i < NUMBER_OF_CHANNELS; i++)		//Display contents to Adc_Results
	{
		printf ("CH %d:%x ",i,Adc_Results[i]);	//print the hex
	}

	printf("\n channel 0 %x", convert_channel(0));		//Convert a single channel and display
	printf("\n channel 1 %x", convert_channel(1));		
	printf("\n channel 2 %x", convert_channel(2));
	printf("\n channel 3 %x", convert_channel(3));
   	printf("\n channel 4 %x", convert_channel(4));
	printf("\n channel 5 %x", convert_channel(5));
	printf("\n channel 6 %x", convert_channel(6));
	printf("\n channel 7 %x", convert_channel(7));

	while(1);											//End Program, Start infinite loop since there is no OS
}